
bool reset;

StructuredBuffer<float3> resetPos;
StructuredBuffer<float3> Dir;

struct particle
{
	float3 pos;
	float3 vel;
};
RWStructuredBuffer<particle> Output : BACKBUFFER;

float3 velocity;
uint total;
float amount;
float maxradius;
//==============================================================================
//COMPUTE SHADER ===============================================================
//==============================================================================

[numthreads(64, 1, 1)]
void CSConstantForce( uint3 DTid : SV_DispatchThreadID )
{
	if (reset)
	{
		Output[DTid.x].pos = resetPos[DTid.x];
		Output[DTid.x].vel = 0;		
	}
	
	else
	{
		uint count=DTid.x;
//		Output[DTid.x].pos=Output[0].pos;
		float3 c=0;
		for( uint i = 0; i < total; i++ )
		{
			if (DTid.x == i)
			{c += Output[i].pos;}
			
			c=c/(total-1);
			
		}
		
		Output[DTid.x].pos += (c-Output[DTid.x].pos)/100;
		
		
		
		
		
		
	}
//		float3 p = Output[DTid.x].pos;	
//		float3 p2 = Output[i].pos;

//		if (distance(p,p2)<maxradius);
	
//		Output[i].pos += p2;
		
//		}

//		Output[DTid.x].pos = (Output[DTid.x].pos/(total-1))-(Output[DTid.x].pos/amount);
		
}		
	


//==============================================================================
//TECHNIQUES ===================================================================
//==============================================================================

technique11 simulation
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CSConstantForce() ) );
	}
}
