
bool reset;

StructuredBuffer<float3> resetPos;


struct particle
{
	float3 pos;
	float3 vel;
};
RWStructuredBuffer<particle> Output : BACKBUFFER;


int total;
float atraction=1;
float3 centre;
float amount=1;
float maxradius;
//==============================================================================
//COMPUTE SHADER ===============================================================
//==============================================================================

[numthreads(64, 1, 1)]
void CSConstantForce( uint3 DTid : SV_DispatchThreadID )
{
	if (reset)
	{
		Output[DTid.x].pos = resetPos[DTid.x];
		Output[DTid.x].vel = 0;		
	}
	
	else
	{
float3 d=0;
		float3 c=0;
		for( uint i = 0; i < total; i++ )
		{
			if (DTid.x != i)
			{c += Output[i].pos;}
			
			c=c/(total-1); //get average positon of all boids
			if (distance(Output[DTid.x].pos,Output[i].pos) < maxradius) //if I'm within range
				{
					d = (Output[DTid.x].pos-Output[i].pos)*amount;
		}
		c+=centre;
		Output[DTid.x].pos += (c-Output[DTid.x].pos)/(total)*atraction+(d);
	}
	
	
	
	}
	
	
}



//==============================================================================
//TECHNIQUES ===================================================================
//==============================================================================

technique11 simulation
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CSConstantForce() ) );
	}
}
